import java.util.Calendar;

public class Compromisso {
   private Data data;
   private Hora hora;
   private boolean realizado;
   private String descricao;
   private String tipo;

   public Compromisso() {
      this.data = new Data();
      this.hora = new Hora();
      this.realizado = false;
      this.descricao = "";
      this.tipo = "Profissional";
   }

   public void setData(Data dataNova) {
      this.data = dataNova;
   }

   public void setHora(Hora horaNova) {
      this.hora = horaNova;
   }

   public void setHora(String hora) {
      this.hora = Hora.transHora(hora);
   }

   public void setData(String data) throws FormatoInvalidoException,
     NumeroInvalidoException {
      this.data = Data.transData(data);
   }

   public void setRealizado(boolean jaOcorreu) {
      this.realizado = jaOcorreu;
   }

   public void setDescricao(String desc) {
      this.descricao = desc;
   }

   public void setTipo(String tipo) {
      this.tipo = tipo;
   }

   public String getTipo() {
      return this.tipo;
   }

   public Data getData() {
      return this.data;
   }

   public Hora getHora() {
      return this.hora;
   }

   public boolean getRealizado() {
      return this.realizado;
   }

   public String getDescricao() {
      return this.descricao;
   }

   public String getDataString() {
      return this.getData().toString();
   }

   public String getHoraString() {
      return this.getHora().toString();
   }

   public char getRealizadoC() {
      char ret = 'n';
      if (this.getRealizado()) {
         ret = 's';
      }
      return ret;
   }

   public void setRealizado(String a) {
      if (a != null && a.equals("s")) {
         this.realizado = true;
      }
      else {
         this.realizado = false;
      }
   }
}