import java.util.*;
import java.sql.*;

//import javax.sql.*;

public class Negocio {

   Connection conec;
   Statement sta;

   public Negocio(String url, String usua, String passw) throws
     ClassNotFoundException, SQLException {
      this.Conexao(url, usua, passw);
      /**sta = conec.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,
                                  ResultSet.CONCUR_UPDATABLE);*/
      sta = conec.createStatement();
   }

   public void close() throws SQLException {
      sta.close();
      /**sta = conec.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,
                                  ResultSet.CONCUR_UPDATABLE);*/
      sta = conec.createStatement();
   }

   public static void main(String args[]) {
      try {
         Negocio neg = new Negocio(
           "jdbc:odbc:sgbd",
           "gapo", "gapo");

         //neg.cadastrarUsuario("Gustavo", "gapo", "010101");

         Servicos novo = new Servicos("Restaurante Status", "Restaurante",
                                      new
                                      Endereco(
           "Av. Dr. Jose Augusto Moreira, 639",
           "Casa Caiada", "Olinda",
           "53808-260", "PE", "Brasil"));
         Vector tel = new Vector();
         tel.add("32659887");
         tel.add("46546123");
         tel.add("89865235");
         tel.add("87965423");
         tel.add("32164798");
         novo.setTelefones(tel);
         neg.cadastrarServico("laon", novo);
         //neg.cadastrarUsuario("Pablo", "pab", "1212121");
         //neg.existeEnd("laon", novo.getEndereco());

         neg.closeConnection();
         System.exit(0);
      }
      catch (ClassNotFoundException e) {
         System.out.println("" + e.getCause() + " - " + e.getException() +
                            " - " + e.getMessage() + " - " + e.getClass() +
                            " - " + e.getLocalizedMessage());
      }
      catch (Exception e) {
         e.printStackTrace();
      }
   }

   /***************************************************************
    *                              Usurio                         *
    ***************************************************************/

   /**
    * Cadastrar Usurio
    */
   public void cadastrarUsuario(String nome, String login, String senha) throws
     SQLException {
      Usuario temp = new Usuario(nome, login, senha);
      String sql = "INSERT INTO Usuarios Values('" + nome + "','" + login +
        "','" + senha + "');";
      sta.executeUpdate(sql);
      this.close();
   }

   /**
    * Descadastrar Usurio
    */

   public void descadastrarUsuario(Usuario usuario) throws SQLException {
      String sql = "DELETE FROM Usuarios WHERE Usuario.login = '" +
        usuario.getLogin() + "'";
      sta.executeUpdate(sql);
      sta.close();
   }

   public void descadastrarUsuario(String login) throws SQLException {
      String sql = "DELETE FROM Usuarios WHERE Usuario.login = '" + login + "'";
      sta.executeUpdate(sql);
      sta.close();
   }

   /**
    * Modificar Login
    */

   public void modificarLogin(String loginAntigo, String loginNovo) throws
     SQLException {
      String sql = "UPDATE Usuarios SET login='" + loginNovo +
        "' WHERE login = '" + loginAntigo + "'";
      sta.executeUpdate(sql);
      sta.close();
   }

   /**
    * Modificar Nome
    */
   public void modificarNome(String loginAntigo, String nome) throws
     SQLException {
      String sql = "UPDATE Usuarios SET nome='" + nome + "' WHERE login = '" +
        loginAntigo + "'";
      sta.executeUpdate(sql);
      sta.close();
   }

   /**
    * MOdificar Senha
    */

   public void modificarSenha(String loginAntigo, String senha) throws
     SQLException {
      String sql = "UPDATE Usuarios SET senha='" + senha + "' WHERE login = '" +
        loginAntigo + "'";
      sta.executeUpdate(sql);
      sta.close();
   }

   /**********************************************************************
    ***********************************************************************
    **                                                                   **
    **                        Compromissos                               **
    **                                                                   **
    ***********************************************************************
    **********************************************************************/

   /**
    * Cadastrar novo compromisso
    */
   public void cadastrarCompromisso(Compromisso compromisso) throws
     SQLException {

   }

   /**
    * Descadastrar compromisso
    */
   public void descadastrarCompromisso(Compromisso compromisso) throws
     SQLException {
   }

   /**
    * Obter todos os compromissos
    *
    * retorno:      um vector com todos os compromissos do usurio
    */

   public Vector getTodosCompromissos(String login) throws SQLException {
      Vector temp = new Vector();

      return temp;
   }

   /**
    * Obter todos os compromissos j realizados
    *
      * retorno:      um vector com todos os compromissos j realizados do usurio
    */

   public Vector getCompromissosRealizados(String login) {
      Vector temp = new Vector();

      return temp;
   }

   /**
    * Obter todos os compromissos ainda no realizados
    *
      * retorno:      um vector com todos os compromissos no realizados do usurio
    */

   public Vector getCompromissosNaoRealizados(String login) {
      Vector temp = new Vector();

      return temp;
   }

   /**
    * Obter compromissos no intervalo de datas
    *
    * retorno:      um vector com todos os compromissos do usurio no determinado intervalo e datas
    */

   public Vector getCompromissos(String login, Calendar inicial, Calendar fim) {
      Vector temp = new Vector();

      return temp;
   }

   /**
    * Obter compromissos de determinada data
    *
    * retorno:      um vector com todos os compromissos do usurio de determinada data
    */

   public Vector getCompromissosData(String login, Calendar data) {
      Vector temp = new Vector();

      return temp;
   }

   /**
    * Obter compromissos no intervalo de datas que j foram realizados
    *
      * retorno:      um vector com todos os compromissos do usurio no determinado
    *               intervalo de datas e que foram realizados
    */

   public Vector getCompromissosRealizado(String login, Calendar inicial,
                                          Calendar fim) {
      Vector temp = new Vector();

      return temp;
   }

   /**
    * Obter compromissos no intervalo de datas que no foram realizados
    *
      * retorno:      um vector com todos os compromissos do usurio no determinado
    *               intervalo de datas e que no foram realizados
    */

   public Vector getCompromissosNaoRealizado(String login, Calendar inicial,
                                             Calendar fim) {
      Vector temp = new Vector();

      return temp;
   }

   /**
    * Obter compromissos que contenha a string
    *
    * retorno:      um vector com todos os compromissos do usurio que contenha a string
    */

   public Vector getCompromissosDescricao(String login, String descricao) {
      Vector temp = new Vector();

      return temp;
   }

   /**
    * Obter todos os compromissos do tipo profissional
    *
      * retorno:      um vector com todos os compromissos profissionais do usurio
    */

   public Vector getCompromissosProfissionais(String login) {
      Vector temp = new Vector();
      String tipo = "Profissional";

      return temp;
   }

   /**
    * Obter todos os compromissos do tipo profissional em determinada data
    *
    * retorno:      um vector com todos os compromissos profissionais do usurio em determinada data
    */

   public Vector getCompromissosProfissionaisData(String login, Calendar data) {
      Vector temp = new Vector();
      String tipo = "Profissional";

      return temp;
   }

   /**
    * Obter todos os compromissos do tipo profissional no intervalo de datas
    *
      * retorno:      um vector com todos os compromissos profissionais do usurio
    *               no determinado intervalo de datas
    */

   public Vector getCompromissosProfissionais(String login, Calendar inicial,
                                              Calendar fim) {
      Vector temp = new Vector();
      String tipo = "Profissional";

      return temp;
   }

   /**
    * Obter todos os compromissos do tipo profissional no intervalo de datas j realizado
    *
      * retorno:      um vector com todos os compromissos profissionais do usurio
    *               no determinado intervalo de datas j realizado
    */

   public Vector getCompromissosProfissionalRealizado(String login,
     Calendar inicial, Calendar fim) {
      Vector temp = new Vector();
      String tipo = "Profissional";

      return temp;
   }

   /**
    * Obter todos os compromissos do tipo profissional j realizado
    *
      * retorno:      um vector com todos os compromissos profissionais do usurio
    *                j realizado
    */

   public Vector getCompromissosProfissionalRealizado(String login) {
      Vector temp = new Vector();
      String tipo = "Profissional";

      return temp;
   }

   /**
    * Obter todos os compromissos do tipo profissional no intervalo de datas nao realizado
    *
      * retorno:      um vector com todos os compromissos profissionais do usurio
    *               no determinado intervalo de datas nao realizado
    */

   public Vector getCompromissosProfissionalNaoRealizado(String login,
     Calendar inicial, Calendar fim) {
      Vector temp = new Vector();
      String tipo = "Profissional";

      return temp;
   }

   /**
    * Obter todos os compromissos do tipo profissional nao realizado
    *
      * retorno:      um vector com todos os compromissos profissionais do usurio
    *                nao realizado
    */

   public Vector getCompromissosProfissionalNaoRealizado(String login) {
      Vector temp = new Vector();
      String tipo = "Profissional";

      return temp;
   }

   /**
    * Obter todos os compromissos do tipo profissional que contenha a string
    *
      * retorno:      um vector com todos os compromissos profissionais do usurio
    *               que contenha a string
    */

   public Vector getCompromissosProfissionalDescricao(String login,
     String descricao) {
      Vector temp = new Vector();
      String tipo = "Profissional";

      return temp;
   }

   /**
    * Obter todos os compromissos do tipo pessoal
    *
    * retorno:      um vector com todos os compromissos pessoais do usurio
    */

   public Vector getCompromissosPessoais(String login) {
      Vector temp = new Vector();
      String tipo = "Pessoal";

      return temp;
   }

   /**
    * Obter todos os compromissos do tipo pessoal no intervalo de datas
    *
    * retorno:      um vector com todos os compromissos pessoal do usurio
    *               no determinado intervalo de datas
    */

   public Vector getCompromissosPessoal(String login, Calendar inicial,
                                        Calendar fim) {
      Vector temp = new Vector();
      String tipo = "Pessoal";

      return temp;
   }

   /**
    * Obter todos os compromissos do tipo pessoal em determinada data
    *
    * retorno:      um vector com todos os compromissos pessoal do usurio
    *               em determinada data
    */

   public Vector getCompromissosPessoalData(String login, Calendar inicial) {
      Vector temp = new Vector();
      String tipo = "Pessoal";

      return temp;
   }

   /**
      * Obter todos os compromissos do tipo pessoal no intervalo de datas j realizado
    *
    * retorno:      um vector com todos os compromissos pessoal do usurio
    *               no determinado intervalo de datas j realizado
    */

   public Vector getCompromissosPessoalRealizado(String login, Calendar inicial,
                                                 Calendar fim) {
      Vector temp = new Vector();
      String tipo = "Pessoal";

      return temp;
   }

   /**
    * Obter todos os compromissos do tipo pessoal no intervalo de datas no realizado realizado
    *
    * retorno:      um vector com todos os compromissos pessoal do usurio
    *               no determinado intervalo de datas no realizado
    */

   public Vector getCompromissosPessoalNaoRealizado(String login,
     Calendar inicial, Calendar fim) {
      Vector temp = new Vector();
      String tipo = "Pessoal";

      return temp;
   }

   /**
    * Obter todos os compromissos do tipo pessoal j realizado
    *
    * retorno:      um vector com todos os compromissos pessoais do usurio j realizados
    */

   public Vector getCompromissosPessoalRealizados(String login) {
      Vector temp = new Vector();
      String tipo = "Pessoal";

      return temp;
   }

   /**
    * Obter todos os compromissos do tipo pessoal no realizado
    *
    * retorno:      um vector com todos os compromissos pessoais do usurio no realizados
    */

   public Vector getCompromissosPessoalNaoRealizados(String login) {
      Vector temp = new Vector();
      String tipo = "Pessoal";

      return temp;
   }

   /**
      * Obter todos os compromissos do tipo pessoal que contenha a string na descricao
    *
    * retorno:      um vector com todos os compromissos pessoais do usurio
    *               que contenha a string na descricao
    */

   public Vector getCompromissosPessoalDescricao(String login, String descricao) {
      Vector temp = new Vector();
      String tipo = "Pessoal";

      return temp;
   }

   /**
    * Modificar compromisso
    *
    * retorno:      - true  : modificado com sucesso
    *               - false : no foi modificado
    */

   public boolean setCompromisso(String login, Compromisso antigo,
                                 Compromisso novo) {
      boolean retorno = false;

      return retorno;
   }

   /**********************************************************************
    ***********************************************************************
    **                                                                   **
    **                            Contatos                               **
    **                                                                   **
    ***********************************************************************
    **********************************************************************/

   /**
    * Cadastrar Contato
    * retorno   - true  :  cadastro realizado
    *           - false :  cadastro no realizado
    */

   public boolean cadastrarContato(String login, Contato contato) {
      boolean retorno = false;
      return retorno;
   }

   /**
    * Descadastrar Contato
    * retorno   - true  :  descadastro realizado
    *           - false :  descadastro no realizado
    */

   public boolean descadastrarContato(String login, Contato contato) {
      boolean retorno = false;
      return retorno;
   }

   /**
    * Obter todos os contatos
    */

   public Vector getContatos(String login) {
      Vector temp = new Vector();

      return temp;
   }

   /**
    * Obter todos os contatos com o determinado por nome
    */

   public Vector getContatosNome(String login, String nome) {
      Vector temp = new Vector();

      return temp;
   }

   /**
    * Obter todos os contatos pela data de aniversrio
    */

   public Vector getContatosAniversario(String login, Calendar niver) {
      Vector temp = new Vector();

      return temp;
   }

   /**
    * Obter todos os contatos pela data de aniversrio (intervalo de datas)
    */

   public Vector getContatosAniversario(String login, Calendar inicio,
                                        Calendar fim) {
      Vector temp = new Vector();

      return temp;
   }

   /**
    * Obter todos os contatos do tipo amigo
    */

   public Vector getContatosAmigo(String login) {
      Vector temp = new Vector();
      String tipo = "Amigos";

      return temp;
   }

   /**
    * Obter todos os contatos do tipo amigo com determinado nome
    */

   public Vector getContatosAmigoNome(String login, String nome) {
      Vector temp = new Vector();
      String tipo = "Amigos";

      return temp;
   }

   /**
    * Obter todos os contatos do tipo amigo com aniversrio naquela data
    */

   public Vector getContatosAmigoAniversario(String login, Calendar niver) {
      Vector temp = new Vector();
      String tipo = "Amigos";

      return temp;
   }

   /**
      * Obter todos os contatos do tipo amigo com o aniversrio no intervalo de datas
    */

   public Vector getContatosAmigoAniversario(String login, Calendar inicio,
                                             Calendar fim) {
      Vector temp = new Vector();
      String tipo = "Amigos";

      return temp;
   }

   /**
    * Obter todos os contatos do tipo profissional
    */

   public Vector getContatosProfissional(String login) {
      Vector temp = new Vector();
      String tipo = "Profissional";

      return temp;
   }

   /**
    * Obter todos os contatos do tipo profissional com determinado nome
    */

   public Vector getContatosProfissionalNome(String login, String nome) {
      Vector temp = new Vector();
      String tipo = "Profissional";

      return temp;
   }

   /**
    * Obter todos os contatos do tipo Profissional com aniversrio naquela data
    */

   public Vector getContatosProfissionalAniversario(String login,
     Calendar niver) {
      Vector temp = new Vector();
      String tipo = "Profissional";

      return temp;
   }

   /**
    * Obter todos os contatos do tipo Profissional com o aniversrio no intervalo de datas
    */

   public Vector getContatosProfissionalAniversario(String login,
     Calendar inicio, Calendar fim) {
      Vector temp = new Vector();
      String tipo = "Profissional";

      return temp;
   }

   /**
    * Obter todos os contatos do tipo profissional que trabalhem em determinado setor
    */

   public Vector getContatosProfissionalSetor(String login, String setor) {
      Vector temp = new Vector();
      String tipo = "Profissional";

      return temp;
   }

   /**
    * Obter todos os contatos do tipo Familia
    */

   public Vector getContatosFamilia(String login) {
      Vector temp = new Vector();
      String tipo = "Familia";

      return temp;
   }

   /**
    * Obter todos os contatos do tipo Familia com determinado nome
    */

   public Vector getContatosFamiliaNome(String login, String nome) {
      Vector temp = new Vector();
      String tipo = "Familia";

      return temp;
   }

   /**
    * Obter todos os contatos do tipo Familia com aniversrio naquela data
    */

   public Vector getContatosFamiliaAniversario(String login, Calendar niver) {
      Vector temp = new Vector();
      String tipo = "Familia";

      return temp;
   }

   /**
    * Obter todos os contatos do tipo Familia com o aniversrio no intervalo de datas
    */

   public Vector getContatosFamiliaAniversario(String login, Calendar inicio,
                                               Calendar fim) {
      Vector temp = new Vector();
      String tipo = "Familia";

      return temp;
   }

   /**
      * Obter todos os contatos do tipo Familia com determinado grau de parentesco
    */

   public Vector getContatosFamiliaParentesco(String login, String grau) {
      Vector temp = new Vector();
      String tipo = "Familia";

      return temp;
   }

   /**
    * Modificar contato
    * retorno:   - true  : modificado com sucesso
    *            - false : no modificado
    */

   public boolean modificarContato(String login, Contato antigo, Contato novo) {
      boolean retorno = false;

      return retorno;
   }

   /**********************************************************************
    ***********************************************************************
    **                                                                   **
    **                        Servios teis                             **
    ** update de endereo: primeiro endereco depois telefone!!!                                                                  **
    ***********************************************************************
    **********************************************************************/

   public Vector vectorEnd(String sql, String where, String coluna) throws
     SQLException {
      Vector retorno = new Vector();
      String cod = sql + where;
      ResultSet res = sta.executeQuery(cod);
      while (res.next()) {
         retorno.add(res.getString(coluna));
      }
      this.close();
      return retorno;
   }

   public boolean existeEnd(String login, Endereco end) throws SQLException {
      boolean retorno = false;
      String sql1 = "select s.ender.logradouro from Serv" + login + " s;";
      String sql2 = "select s.ender.bairro from Serv" + login + " s;";
      String sql3 = "select s.ender.cidade from Serv" + login + " s;";
      String sql4 = "select s.ender.cep from Serv" + login + " s;";
      String sql5 = "select s.ender.estado from Serv" + login + " s;";
      String sql6 = "select s.ender.pais from Serv" + login + " s;";
      Iterator[] todos = new Iterator[6];
      todos[0] = this.vectorEnd(sql1, "", "ender.logradouro").iterator();
      todos[1] = this.vectorEnd(sql2, "", "ender.bairro").iterator();
      todos[2] = this.vectorEnd(sql3, "", "ender.cidade").iterator();
      todos[3] = this.vectorEnd(sql4, "", "ender.cep").iterator();
      todos[4] = this.vectorEnd(sql5, "", "ender.estado").iterator();
      todos[5] = this.vectorEnd(sql6, "", "ender.pais").iterator();
      while (todos[0].hasNext()) {
         if ( ( (String) todos[0].next()).compareToIgnoreCase(end.getLogradouro()) ==
             0 &&
             ( (String) todos[1].next()).compareToIgnoreCase(end.getBairro()) ==
             0 &&
             ( (String) todos[2].next()).compareToIgnoreCase(end.getCidade()) ==
             0 &&
             ( (String) todos[3].next()).compareToIgnoreCase(end.getCep()) == 0 &&
             ( (String) todos[4].next()).compareToIgnoreCase(end.getEstado()) ==
             0 &&
             ( (String) todos[5].next()).compareToIgnoreCase(end.getPais()) ==
             0) {
            retorno = true;
         }
      }
      return retorno;
   }

   /**
    * Cadastrar Servico
    */

   public void cadastrarServico(String login, Servicos novo) throws
     SQLException, ObjetoExistenteException {
      String sql = "SELECT tname from tab;";
      ResultSet res = sta.executeQuery(sql);
      boolean existe = false;
      while (res.next() && !existe) {
         if (res.getString("tname").compareToIgnoreCase("Serv" + login) == 0) {
            existe = true;
         }
      }
      if (existe) {
         if (!existeEnd(login, novo.getEndereco())) {
            sql = "INSERT INTO Serv" + login + " VALUES(" + novo.toString() +
              ");";
            sta.executeUpdate(sql);
         }
         else {
            throw new ObjetoExistenteException("Servio j Cadastrado!");
         }
      }
      else {
         sql = "CREATE TABLE Serv" + login + " OF SERVICOS;";
         sta.executeUpdate(sql);
         this.cadastrarServico(login, novo);
      }
      this.close();
   }

   /**
    * Desadastrar Servico
    * retorno:   - true  : servico descadastrado
    *            - false : servio no descadastrado
    */

   public boolean descadastrarServico(String login, Servicos antigo) {
      boolean retorno = false;

      return retorno;
   }

   /**
    * Modificar Servico
    * retorno:   - true  : servico modificado
    *            - false : servio no modificado
    */

   public boolean modificarServico(String login, Servicos antigo, Servicos novo) {
      boolean retorno = false;

      return retorno;
   }

   /**
    * Obter todos os servicos
    */

   public Vector getServicos(String login) {
      Vector temp = new Vector();
      return temp;
   }

   /**
    * Obter todos os servicos de determinada categoria
    */

   public Vector getServicosCategoria(String login, String categoria) {
      Vector temp = new Vector();
      return temp;
   }

   /**
    * Obter todos os servicos de determinada endereo
    */

   public Vector getServicosEndereco(String login, Endereco end) {
      Vector temp = new Vector();
      return temp;
   }

   /**
    * Obter todos os servicos de determinada bairro
    */

   public Vector getServicosBairro(String login, String bairro) {
      Vector temp = new Vector();
      return temp;
   }

   /**
    * Obter todos os servicos de determinada cidade
    */

   public Vector getServicosCidade(String login, String cidade) {
      Vector temp = new Vector();
      return temp;
   }

   /**
    * Obter todos os servicos de determinada descricao
    */

   public Vector getServicosDescricao(String login, String descricao) {
      Vector temp = new Vector();
      return temp;
   }

   /**********************************************************************
    ***********************************************************************
    **                                                                   **
    **                            Mensagem  (eu)                             **
    **                                                                   **
    ***********************************************************************
    **********************************************************************/

   /**
    * Cadastrar Mensagem
    * retorno:   - true  : mensagem cadastrado
    *            - false : mensagem no cadastrado
    */

   public boolean cadastrarMensagem(String login, Mensagem novo) {
      boolean retorno = false;

      return retorno;
   }

   /**
    * Desadastrar Mensagem
    * retorno:   - true  : mensagem descadastrado
    *            - false : mensagem no descadastrado
    */

   public boolean descadastrarMensagem(String login, Mensagem antigo) {
      boolean retorno = false;

      return retorno;
   }

   /**
    * Modificar Mensagem
    * retorno:   - true  : mensagem modificado
    *            - false : mensagem no modificado
    */

   public boolean modificarMensagem(String login, Mensagem antigo,
                                    Mensagem novo) {
      boolean retorno = false;
      return retorno;
   }

   /**
    * Obter todas Mensagens
    */
   public Vector getMensagem(String login) {
      Vector temp = new Vector();
      return temp;
   }

   /**
    * Obter todas Mensagens com determinado ttulo
    */
   public Vector getMensagemTitulo(String login, String titulo) {
      Vector temp = new Vector();
      return temp;
   }

   /**
    * Obter todas Mensagens com determinado descricao
    */
   public Vector getMensagemDescricao(String login, String descricao) {
      Vector temp = new Vector();
      return temp;
   }

   /**
    * Mtodo de conexo com o banco de dados
    */

   public void Conexao(String url, String user, String passwd) throws
     ClassNotFoundException, SQLException {
      Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
      //Class.forName("oracle.jdbc.driver.OracleDriver");
      conec = DriverManager.getConnection(url, user, passwd);
   }

   public void closeConnection() throws SQLException {
      this.conec.close();
   }
}