import java.util.Vector;
import java.util.Iterator;

public class Servicos {
   private String descricao;
   private String categoria;
   private Endereco endereco;
   private Vector telefones;

   public Servicos() {
      this.descricao = "";
      this.categoria = "";
      this.endereco = new Endereco();
      this.telefones = new Vector();
   }

   public Servicos(String d, String c, Endereco e) {
      this.descricao = d;
      this.categoria = c;
      this.endereco = e;
      this.telefones = new Vector();
   }

   public String getDescricao() {
      return this.descricao;
   }

   public String getCategoria() {
      return this.categoria;
   }

   public Endereco getEndereco() {
      return this.endereco;
   }

   public Vector getTelefones() {
      return this.telefones;
   }

   public void setDescricao(String d) {
      this.descricao = d;
   }

   public void setCategoria(String c) {
      this.categoria = c;
   }

   public void setEndereco(Endereco e) {
      this.endereco = e;
   }

   public void setTelefones(Vector v) {
      this.telefones = v;
   }

   public String toString() {
      String ret = "'" + this.getDescricao() + "',Endereco(" +
        this.getEndereco().toString() + "),'" + this.getCategoria() +
        "',Telefone_array(";
      Iterator it = this.getTelefones().iterator();
      while (it.hasNext()) {
         ret = ret + "'" + it.next() + "'";
         if (it.hasNext()) {
            ret = ret + ",";
         }
      }
      ret = ret + ")";
      return ret;
   }

   /*    public void insereTelefone(String fone){
              this.telefones.add(fone);
       }
       public boolean removerTelefone(String fone){
            boolean retorno = false;
            if (this.telefones.contains(fone)){
                retorno = this.telefones.remove(fone);
            }
            return retorno;
       }
       public boolean setTelefone(String antigo, String novo){
            boolean retorno = false;
            if (this.telefones.contains(antigo)){
                int indice = this.telefones.indexOf(antigo)
                this.telefones.add(indice,novo);
                retorno = true;
            }
            return retorno;
       }*/

}
