public class ElementoNuloException
  extends Exception {
   private String mensagem;

   /**
    * Construtor da classe ElementoNuloException
    *
    * @param mensagem de erro     recebe uma String contendo a mensagem de erro
    */
   public ElementoNuloException(String mensagemDeErro) {
      this.mensagem = mensagemDeErro;
   }

   /**
    * Metodo que obtem e retorna a mensagem de erro da excecao
    *
    * @return     A mensagem de erro do tipo String
    */
   public String getMensagem() {
      return this.mensagem;
   }

}
