public class FormatoInvalidoException
  extends Exception {
   private String entrada;
   private String formatoValido;

   /**
    * Construtor da classe IllegalArgumentException
    *
    * @param entrada         recebe a String lida e nao aceita
    * @param formatoValido   recebe uma String contendo o formato valido do argumento
    */
   public FormatoInvalidoException(String entrada, String formatoValido) {
      this.entrada = entrada;
      this.formatoValido = formatoValido;
   }

   /**
    * Metodo que retorna uma String com a mensagem informando o erro encontrado
    *
    * @return mensagem    a mensagem explicando qual foi o erro
    */
   public String getMensagem() {
      String mensagem = "Erro: O formato expecificado nao e valido!";
      mensagem = mensagem + "\n Esperado: " + this.formatoValido
        + "\tEncontrado:" + this.entrada;
      return mensagem;
   }

}
